//
//  APAudioToRingVC+Style.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/19.
//

extension APAudioToRingVC {
 
    func creatFileView() -> ASRTRFileView {
        let fileView = ASRTRFileView { [weak self] in
            guard let self = self else { return }
            ASMediaPlayerController.main.stopPlayback()
            selectAudioFile()
        } clickPlayComplete: { [weak self] in
            guard let self = self else { return }
            clickPlay()
        }
        return fileView
    }
    
    
    func clickPlay() {
        if ASMediaPlayerController.main.isBuffering{
            return
        }
        if ASMediaPlayerController.main.isActive{
            ASMediaPlayerController.main.stopPlayback()
        }else{
            ASMediaPlayerController.main.startPlayback(localPath:viewModel.ringFilePath)
        }
    }
}


extension APAudioToRingVC : UIDocumentPickerDelegate {

  @objc func selectAudioFile() {
//      if viewModel.ringFilePath == nil {
//          if let url = Bundle.main.url(forResource: "DanceRingtoneExample", withExtension: "mp3") {
//              viewModel.ringFilePath = url
//              fileView.filePath = url
//          }
//      }else{
//          viewModel.ringFilePath = nil
//          fileView.filePath = nil
//      }
//      
//      return
      let documentTypes = ["public.mp3"]
      // 音频 mp3，wav，m4a
      // .MP3; .AAC; .WAV; .WMA; .CDA; .FLAC; .M4A; .MID; .MKA; .MP2; .MPA; .MPC; .APE; .OFR; .OGG; .RA; .WV; .TTA; .AC3; .DTS
      // 视频 mp4，avi, wmv，mov，mpg(mpeg)
      
      // 1. 创建文件选择器
      let documentPicker = UIDocumentPickerViewController(
          documentTypes: documentTypes,//[kUTTypeAudio as String], // 限定音频类型
          in: .import//.open // 打开模式（只读）
      )
      documentPicker.delegate = self
      documentPicker.modalPresentationStyle = .fullScreen
      documentPicker.allowsMultipleSelection = false // 禁止多选
      
      // 2. 弹出文件选择器
      present(documentPicker, animated: true, completion: nil)
  }
    
    // 用户选中文件后回调
    func documentPicker(_ controller: UIDocumentPickerViewController, didPickDocumentsAt urls: [URL]) {
        guard let selectedFileURL = urls.first else { return }
        
        // 3. 处理选中的音频文件
        print("选中的音频文件路径:", selectedFileURL.path)
        let cacheDirectory = ASFileManager.cacheDirectory().appendingPathComponent(selectedFileURL.lastPathComponent)
        ASFileManager.copyFileWithOverwrite(from: selectedFileURL, to: cacheDirectory)
        viewModel.ringFilePath = cacheDirectory
        fileView.filePath = cacheDirectory
    }

    // 用户取消选择时回调
    func documentPickerWasCancelled(_ controller: UIDocumentPickerViewController) {
        print("用户取消了选择")
    }

}

