//
//  ASMyRingCell.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/19.
//

import Combine
import SwipeCellKit
class ASMyRingCell: SwipeCollectionViewCell  {

    weak var targetVC:UIViewController?
    var indexPath:IndexPath = IndexPath(item: 0, section: 0)
    override init(frame: CGRect) {
        super.init(frame: frame)
        creatUI()
        dealThings()
    }
    
    required public init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    static let cellID = "ASMyRingCell"

    lazy var ringView: ASRingToneCellView = {
        let ringToneView = ASRingToneCellView()
        ringToneView.cornerRadius = 0.0
        ringToneView.setRingBtn.isHidden = false
        ringToneView.editBtn.isHidden = true
        ringToneView.clickPlayHandel = { [weak self] isplay in
            guard let self = self else { return }
            clickPlay()
        }
        
//        ringToneView.clickEditHandel = { [weak self] in
//            guard let self = self else { return }
//            clickEidtBtn()
//        }
        
        ringToneView.clickSetUpHandel = { [weak self] in
            guard let self = self else { return }
            clickSetRingBtn()
      
        }
        return ringToneView
    }()
    
    lazy var generateView: TSRingToneGenerateView = {
        let generateView = TSRingToneGenerateView()
        generateView.isHidden = true
        generateView.refreshHandel = { [weak self]  in
            guard let self = self else { return }
            guard let oldModel = model else { return }

            if oldModel.modelType == .ttr {
                //            if kPurchaseToolShared.kJudgeVipFreeType(vipFreeNumType: .ringtones){ return }//判断 vip
                if ASGenerateTextToRingOperationQueue.shared.isAvailability {
                    generateView.setProgress(progress: 0)
                    let gennerateOperation = ASGenerateTextToRingOperationQueue.shared.creatOperation(uuid: oldModel.uuid)
                    gennerateOperation.isSaveProcessToDB = true
                    gennerateOperation.creatRing(oldModel: oldModel) { success in }
//                    logPrint("\(self.indexPath.item),刷新进度发self.operation=\(gennerateOperation)")
                    modelDidSet()
                }
            }else if oldModel.modelType == .rtr {
                //            if kPurchaseToolShared.kJudgeVipFreeType(vipFreeNumType: .ringtones){ return }//判断 vip
                if ASGenerateRingToRingOperationQueue.shared.isAvailability {
                    generateView.setProgress(progress: 0)
                    let gennerateOperation = ASGenerateRingToRingOperationQueue.shared.creatOperation(uuid: oldModel.uuid)
                    gennerateOperation.isSaveProcessToDB = true
                    gennerateOperation.creatRing(oldModel: oldModel) { success in }
                    modelDidSet()
                }
            }
        }
        return generateView
    }()
    
    
    lazy var exampleView: UIView = {
        let exampleView = UIView()
        exampleView.backgroundColor = "#7E57F4".uiColor
        
        let textLabel = UILabel.createLabel(
            text: "Example".localized,
            font: .font(size: 12),
            textColor: .white
        )
        
        exampleView.addSubview(textLabel)
        textLabel.snp.makeConstraints { make in
            make.top.edges.equalTo(UIEdgeInsets(top: 4, left: 6, bottom: 4, right: 6))
        }
        
        kDelayMainShort {
            exampleView.maskCorner([.topLeft,.bottomLeft], radius: 10)
        }
        return exampleView
    }()
    
    
    lazy var vipView: UIImageView = {
        let vipView = UIImageView.createImageV(imageName: "ring_vip")
        vipView.isHidden = true
        return vipView
    }()
    
    var model:ASActionInfoModel?{
        didSet{
            modelDidSet()
        }
    }

    func creatUI() {
        cornerRadius = 16.0
        backgroundColor = .cardColor
        
        contentView.addSubview(ringView)
        ringView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
    
        contentView.addSubview(vipView)
        vipView.snp.makeConstraints { make in
            make.top.trailing.equalTo(0)
            make.width.height.equalTo(24)
        }
        
        contentView.addSubview(exampleView)
        exampleView.snp.makeConstraints { make in
            make.trailing.equalToSuperview()
            make.top.equalTo(0)
            make.height.equalTo(20)
        }
  
        contentView.addSubview(generateView)
        generateView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
    }
    
    func setTargetVC(targetVC:UIViewController?,indexPath:IndexPath) {
        self.targetVC = targetVC
        self.indexPath = indexPath
        
        if let vc = targetVC as? any SwipeCollectionViewCellDelegate {
          self.delegate = vc
        }
    }
    
    func dealThings(){
        
    }
    
}


extension ASMyRingCell {
    
    var currentOperation:ASGenerateBaseOperation?{
        guard let model = model else { return nil }
//        logPrint("\(self.indexPath.item),刷新进度真self.uuid=\(model.uuid)")
        if model.modelType == .ttr {
            return ASGenerateTextToRingOperationQueue.shared.findOperation(uuid: model.uuid)
        }else if model.modelType == .rtr {
            return ASGenerateRingToRingOperationQueue.shared.findOperation(uuid: model.uuid)
        }
        return nil
    }
    func modelDidSet(){
        guard let model = model else { return }
        
        //处理model数据
        updataActionInfoModelView(model: model)
        logPrint("\(self.indexPath.item),model actionStatus 收到=\(model.actionStatus)")
        
        //处理生成任务
        if let rintoneOperation = currentOperation {
            rintoneOperation.stateDataPblishedChanged = { [weak self] state, actionInfoModel in
                guard let self = self else { return }
                if rintoneOperation.uuid != self.model?.uuid {
                    return
                }
                handleStateDataPblishedChanged(state: state, actionInfoModel: actionInfoModel)
            }
            logPrint("\(self.indexPath.item),刷新进度真handleStateDataPblishedChanged=\(rintoneOperation.stateDatauPblished)")
            handleStateDataPblishedChanged(state: rintoneOperation.stateDatauPblished.0, actionInfoModel: rintoneOperation.stateDatauPblished.1)
        }

        //处理播放进度
        if playSelf{
            setPlayerStateChangedHandle()
        }else{
            changePlayerState(state: .stopped)
        }
    }

    func setPlayerStateChangedHandle(){
        ASMediaPlayerController.main.onStatusChange = { [weak self] playerState in
            guard let self = self else { return }
            logPrint("\(self.indexPath.item),stateChangedHandle self=\(self)")
            
            if playSelf {
                self.changePlayerState(state: playerState)
            }else{
                self.changePlayerState(state: .stopped)
            }

        }
        self.changePlayerState(state: ASMediaPlayerController.main.currentStatus)
    }

}
extension ASMyRingCell {
   
    func handleStateDataPblishedChanged(state:ASProgressState,actionInfoModel:ASActionInfoModel?){
        switch state {
            case .failed(let errorStr,let code):
            generateView.isHidden = false
            generateView.setFail()
            case .success:
            if let model = actionInfoModel {
                updataActionInfoModelView(model: model)
            }
            case .progress(let progress, let string):
            generateView.isHidden = false
            generateView.setProgress(progress: progress)
            default:
            generateView.isHidden = false
            generateView.setProgress(progress: 0)
        }
    }
    
}

extension ASMyRingCell {
    func clickPlay() {
        if playSelf{
            if ASMediaPlayerController.main.isBuffering{
                return
            }
            if ASMediaPlayerController.main.isActive{
                ASMediaPlayerController.main.stopPlayback()
            }else{
                ASMediaPlayerController.main.startPlayback(of:modelUrlString,localPath: modelLocalURL,index: indexPath)
            }
            
        }else{
            ASMediaPlayerController.main.stopPlayback()//让上一个对象停止播放
            setPlayerStateChangedHandle()//更换监听
            ASMediaPlayerController.main.startPlayback(of:modelUrlString,localPath: modelLocalURL,index: indexPath)
        }
    }
    

    func changePlayerState(state:ASMediaPlayerController.PlaybackStatus){
        ringView.handelAudioPlayerStateChange(state: state)
    }
    
    
    func updataActionInfoModelView(model:ASActionInfoModel){
        
        if model.modelType == .example {
            model.actionStatus = .success
        }

        switch model.actionStatus {
        case .pending,.running:
            generateView.isHidden = false
            generateView.setProgress(progress: model.percent*kPercentScale)
        case .success:
            generateView.isHidden = true
            
            ringView.timeLab.text = Float(model.response.duration).timeMMSS
            ringView.nameLab.text = model.response.title
            ringView.setCoverImageView(urlString: model.response.coverUrl)
            exampleView.isHidden = model.modelType != .example
            vipView.isHidden = true
            
            self.changePlayerState(state: ASMediaPlayerController.main.currentStatus)
            
        case .failed:
            generateView.isHidden = false
            generateView.setFail()
        }
    }

    var playSelf:Bool{
        let b = ASMediaPlayerController.main.isCurrentMedia(url: modelUrlString,localPath: modelLocalURL,index: indexPath)
        logPrint("\(self.indexPath.item),playSelf =\(b)")
        return b
    }

    var modelUrlString:String{
        var urlString:String = ""
        if let model = model{
            urlString = model.response.musicUrl
        }
        return urlString
    }

    var modelLocalURL:URL?{
        return model?.localURL
    }
    
}
//点击编辑和设置按钮
extension ASMyRingCell {
    
    @objc func clickSetRingBtn(){
        if let model = model {
            setShareBand(infoModel: model)
        }
    
        ASMediaPlayerController.main.stopPlayback()
    }
    
    func setShareBand(infoModel:ASActionInfoModel){
        guard let targetVC = targetVC else { return }
        let needVip = infoModel.response.vip
        let urlString = infoModel.response.musicUrl
        let fileName = infoModel.response.title
        
        
        if let fileURL = infoModel.localURL {
            _ = kshareBand(needVip: needVip, vc: targetVC, fileURL: fileURL, fileName: fileName)
        }else{
            ASMediaDownloader.fetchMediaResource(remoteURL: urlString){ url,downLoad in
                if let path = url {
                    _ = kshareBand(needVip: needVip, vc: targetVC, fileURL: path, fileName: fileName)
                }
            }
        }
    }
}
