//
//  APRingTonesVC.swift
//  AIPlayRingtones
//
//  Created by 100Years on 2025/5/15.
//

import Combine
class APRingTonesVC: ASBaseViewController {
    lazy var viewModel: APRingTonesVM = {
        let viewModel = APRingTonesVM()
        return viewModel
    }()

//    lazy var vipBtn: UIButton = creatVipBtn()
    lazy var navBarView: ASBaseNavContentBarView = creatNavBarView()
    lazy var cusStackView: ASDynamicContainer = creatDynamicContainer()
    lazy var customTextView: ASPromptTextView = creatCustomTextView()
    lazy var secStyleView: ASGenerateDurationColView = creatDurationCollectionView()
    lazy var ringStyleVC: APRingStyleVC = creatRingStyleVC()
    lazy var creatBtnView: ASAppBtnView = creatCreatBtnView()
    
    public var cancellable: [AnyCancellable] = []
    override func createView() {
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(clickView))
        tapGesture.cancelsTouchesInView = false
        view.addGestureRecognizer(tapGesture)

        navBarContentView.addSubview(navBarView)
        navBarView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }

        contentView.addSubview(cusStackView)
        cusStackView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }

        contentView.addSubview(creatBtnView)
        creatBtnView.snp.makeConstraints { make in
            make.centerX.equalToSuperview()
            make.bottom.equalTo(-16)
            make.size.equalTo(creatBtnView.btnSize)
        }

        
        self.addChild(ringStyleVC)
        setUpCusStackView()
    }
    
    override func dealThings() {
        viewModel.$isCanGennerate.receive(on: DispatchQueue.main).sink { [weak self] enble in
            guard let self = self else { return }
            setCreatBtnEnabled()
        }.store(in: &cancellable)
        
        NotificationCenter.default.addObserver(forName: .kBaseOperationQueueCountChanged, object: nil, queue: .main) { [weak self] notification in
            guard let self = self else { return }
            if let userInfo = notification.userInfo as? [String: Any], let _ = userInfo["ASBaseOperationQueue"] as? ASGenerateTextToRingOperationQueue {
                setCreatBtnEnabled()
            }
        }
    
        NotificationCenter.default.addObserver(forName: .kGenerateTTROperationChanged, object: nil, queue: .main) { [weak self] notification in
            guard let self = self else { return }
            if let userInfo = notification.userInfo as? [String: Any], let state = userInfo["state"] as? ASProgressState {
                if case let .progress(_,progressString) = state {
                    creatBtnView.setLoadingText(text: progressString)
                }
            }
        }
    }
    
    deinit {
        cancellable.removeAll()
    }
    
}


extension APRingTonesVC {
    @objc func clickView() {
        view.endEditing(true)
    }
    
    func setCreatBtnEnabled() {
        let isAvailability = ASGenerateTextToRingOperationQueue.shared.isAvailability
        if viewModel.isCanGennerate, isAvailability {
            creatBtnView.setBtnEnabled(isEnabled: true)
            creatBtnView.loading = false
        } else {
            creatBtnView.setBtnEnabled(isEnabled: false)
            
            let loading = !isAvailability
            if creatBtnView.loading != loading {
                creatBtnView.loading = loading
            }
        }
    }
    
    
    func generateAI() {
        view.endEditing(true)
        let gennerateVC = ASRingGeneratorVC(generateStyleModel: viewModel.generateStyleModel)
        kPresentModalVC(target: self, modelVC: gennerateVC, transitionStyle: .crossDissolve)
    }
    
}
