//
//  ASRingGeneratorBaseVC.swift
//  AIPlayRingtones
//
//  Created by 100Years on 2025/5/18.
//

class ASRingGeneratorBaseVC: ASBaseViewController {
    
    lazy var topBgView: UIView = {
        let topBgView = UIView(frame: CGRectMake(0, 0, k_ScreenWidth, k_ScreenHeight))
        topBgView.backgroundColor = .black.withAlphaComponent(0.5)
        topBgView.addGestureRecognizer(UITapGestureRecognizer(target: self, action: #selector(closePage)))
        return topBgView
    }()
    
    var bottomViewH:CGFloat = 304{
        didSet{
            bottomView.frame = CGRectMake(0, k_ScreenHeight-bottomViewH, k_ScreenWidth, bottomViewH)
        }
    }
    
    lazy var bottomView: UIView = {
        let bottomView = UIView(frame: CGRectMake(0, k_ScreenHeight-bottomViewH, k_ScreenWidth, bottomViewH))
        bottomView.backgroundColor = .mainBg
        return bottomView
    }()

    lazy var titleLabel: UILabel = {
        let titleLabel = UILabel.createLabel(text: "Successfully Generated".localized,font: .font(name: .PoppinsBoldItalic,size: 18.0),textColor: .white,textAlignment: .left)
        return titleLabel
    }()
    
//    lazy var closePageBtn: UIButton = {
//        let xBtn = UIButton.createBtn(image: .pageX) { [weak self]  in
//            guard let self = self else { return }
//            closePage()
//        }
//        return xBtn
//    }()
    
    lazy var xBtn: UIButton = {
        let xBtn = ASTouchBtn()
        xBtn.setUpBtn(image: UIImage(named: "x")) { [weak self]  in
            guard let self = self else { return }
            clickXBtn()
        }
        return xBtn
    }()
    

    lazy var saveBtn: UIButton = {
        let saveBtn = UIButton.createBtn(title:"Set as Ringtone".localized,backgroundImage:.setAsBg,font: UIFont.font(size: 14,weight: .medium),titleColor:.white)
        { [weak self]  in
            guard let self = self else { return }
            clickSubmitBtn()
        }
        return saveBtn
    }()

    //点击空白,关闭页面
    override func createView() {

        view.backgroundColor = .mainBg.withAlphaComponent(0.6)
        setNavBarViewHidden(true)
        contentView.addSubview(topBgView)
        contentView.addSubview(bottomView)
    
        let safeBottom = k_Height_safeAreaInsetsBottom()

        //保存
        bottomView.addSubview(saveBtn)
        saveBtn.snp.makeConstraints { make in
            make.bottom.equalTo(-44-safeBottom)
            make.centerX.equalToSuperview()
            make.width.equalTo(290)
            make.height.equalTo(48)
        }

        bottomView.addSubview(titleLabel)
        titleLabel.snp.makeConstraints { make in
            make.top.equalTo(24)
            make.leading.equalTo(16)
            make.trailing.equalTo(-30)
        }
        
        bottomView.addSubview(xBtn)
        xBtn.snp.makeConstraints { make in
            make.top.equalTo(8)
            make.trailing.equalTo(-6)
            make.width.equalTo(20)
            make.height.equalTo(20)
        }
 
//        contentView.addSubview(closePageBtn)
//        closePageBtn.snp.makeConstraints { make in
//            make.top.equalTo(4.0+k_StatusBar_H)
//            make.leading.equalTo(16.0)
//            make.width.height.equalTo(36)
//        }
    }
    
    @objc func closePage() {
        self.dismiss(animated: true, completion: nil)
    }

    @objc func clickSubmitBtn(){
        
    }

    @objc func clickXBtn(){
        closePage()
    }
}
