//
//  ASRingGeneratorVC+load.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/19.
//

extension ASRingGeneratorVC {
    
    func createGeneratorView() -> ASGeneratorView{
        let generateInView = ASGeneratorView()
        generateInView.animationView.setText(time: String(format: "～ %d min".localized, 2), info: "It may take up a few minutes for you to receive an AI-generated ringtones. You can find your ringtones in ”Mine“ tab.".localized)
        generateInView.clickClosePage = { [weak self] in
            guard let self = self else { return }
            closePage()
        }
        generateInView.clickBackstageBlock = { [weak self]  in
            guard let self = self else { return }
            clickBackstageBtn()
        }
        
        generateInView.clickErrorBlock = { [weak self] style in
            guard let self = self else { return }
            
            switch style {
            case .netWorkError:
                creatRintone()
            case .sensitiveError:
                self.dismiss(animated: true, completion: nil)
            case .generalError:
                self.dismiss(animated: true, completion: nil)
            default:
                break
            }
        }
        return generateInView
    }
    
    
    func upDateView(state:ASProgressState,model:ASActionInfoModel?){
        updateInfoModel(model: model)
        progressState = state
        switch state {
            case .failed(let errorStr,let code):
                showError(text: errorStr,code:code)
            case .success:
                if let model = model {
                    showSuccess(model: model)
                }else{
                    showError(text: "")
                }
            case .progress(let progress, let string):
            showProgress(progress:progress,text: string)
            default:
                showLoading()
        }
    }
    
    func showProgress(progress:Float, text:String) {
        generateInView.updateShowProgress(progress: progress,text: text)
        bottomView.isHidden = true
    }
    
    func showLoading(){
        generateInView.updateShowLoading(progress: 0.0,text: "Generating".localized + " 0%")
        bottomView.isHidden = true
    }
    
    func showError(text:String,code:Int = 0){
        generateInView.updateShowError(text: text,code: code)
        bottomView.isHidden = true
    }
    
    func showSuccess(model:ASActionInfoModel){
        generateInView.updateShowSuccess()
        bottomView.isHidden = false
        infoModel = model
    }
}
