//
//  CustomTabBarController.m
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//
#import "AIPlayRingtones-Swift.h"
#import "CustomTabBarController.h"
#import "NSString+AS.h"
#import "UIColor+AS.h"
#import "GlobalMacros.h"
#import "ASBaseNavigationController.h"

@interface CustomTabBarController ()

@end

@implementation CustomTabBarController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self setupViewControllers];
    [self customizeTabBarAppearance];
}

- (void)setupViewControllers {
    
    APAudioToRingVC *firstVC = [[APAudioToRingVC alloc] init];
    ASBaseNavigationController *firstNav = [[ASBaseNavigationController alloc] initWithRootViewController:firstVC];
    firstNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Audio".localized
                                                        image:[[UIImage imageNamed:@"tabbar_unSelect_audio"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]
                                                selectedImage:[[UIImage imageNamed:@"tabbar_selected_audio"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
    

    APRingTonesVC *secondVC = [[APRingTonesVC alloc] init];
    ASBaseNavigationController *secondNav = [[ASBaseNavigationController alloc] initWithRootViewController:secondVC];
    secondNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Create".localized
                                                         image:[[UIImage imageNamed:@"tabbar_unSelect_create"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]
                                                 selectedImage:[[UIImage imageNamed:@"tabbar_selected_create"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
    
    APMyRingVC *thirdVC = [[APMyRingVC alloc] init];
    ASBaseNavigationController *thirdNav = [[ASBaseNavigationController alloc] initWithRootViewController:thirdVC];
    thirdNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Mine".localized
                                                        image:[[UIImage imageNamed:@"tabbar_unSelect_mine"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]
                                                selectedImage:[[UIImage imageNamed:@"tabbar_selected_mine"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
    
    APSettingVC *fourVC = [[APSettingVC alloc] init];
    ASBaseNavigationController *fourNav = [[ASBaseNavigationController alloc] initWithRootViewController:fourVC];
    fourNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Setting".localized
                                                       image:[[UIImage imageNamed:@"tabbar_unSelect_setting"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]
                                               selectedImage:[[UIImage imageNamed:@"tabbar_selected_setting"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
    
    // 设置标签栏控制器
    self.viewControllers = @[firstNav, secondNav, thirdNav,fourNav];
    self.selectedIndex = 0; // 默认选中第一个
}

- (void)customizeTabBarAppearance {

    self.tabBar.barStyle = UIBarStyleBlack;
    [self.tabBar setTranslucent:NO];
    self.tabBar.backgroundColor = @"#1E1D29".uiColor;
    self.view.backgroundColor = [UIColor blackColor];
    self.tabBar.backgroundImage = [self.tabBar.backgroundColor imageWithSize:CGSizeMake(k_ScreenWidth, k_TabBar_Height)];
     
    [[UITabBar appearance] setUnselectedItemTintColor:[[UIColor whiteColor]colorWithAlphaComponent:0.4]];
    [[UITabBar appearance] setTintColor:[UIColor whiteColor]];
    

}

@end
