//
//  ASGarageBandHelper.h
//  AIPlayRingtones
//
//  Created by mini on 2025/5/28.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <AVKit/AVKit.h>
#import <AVFoundation/AVFoundation.h>
NS_ASSUME_NONNULL_BEGIN

@interface AudioTool : NSObject

- (void)convertToBandFrom:(NSURL *)inputURL
              outputPath:(NSString *)outputPath
            templatePath:(NSString *)templatePath
             completion:(void(^)(NSURL * _Nullable))completion;

@end

@interface ASGarageBandHelper : NSObject<AVPlayerViewControllerDelegate, AVPictureInPictureControllerDelegate>

@property (nonatomic, weak) UIViewController *presentingController;
@property (nonatomic, strong) AVPlayer *mediaPlayer;
@property (nonatomic, strong) AVPictureInPictureController *pipController;
@property (nonatomic, strong) UIView *playerContainer;
@property (nonatomic, strong) AudioTool *audioProcessor;

+ (instancetype)sharedInstance;
+ (instancetype)createHelper;

- (BOOL)verifyGarageBandInstalled;
- (void)shareToGarageBandFrom:(UIViewController *)controller
                    withAudio:(NSURL *)fileURL
                    fileName:(nullable NSString *)fileName
                  completion:(nullable void(^)(BOOL success))completion;


@end

NS_ASSUME_NONNULL_END
