//
//  ASRandomTextTool.m
//  AIPlayRingtones
//
//  Created by mini on 2025/5/28.
//

#import "ASRandomTextTool.h"

@interface ASRandomTextTool ()
@property (nonatomic, strong) NSArray<NSString *> *texts;
@property (nonatomic, assign) NSInteger lastIndex;
@end

@implementation ASRandomTextTool

- (instancetype)initWithTexts:(NSArray<NSString *> *)texts {
    self = [super init];
    if (self) {
        _texts = [texts copy];
        _lastIndex = -1; // 初始化为无效索引
    }
    return self;
}

- (NSString *)getRandomText {
    if (self.texts.count == 0) {
        return nil;
    }
    
    NSInteger randomIndex;
    do {
        randomIndex = arc4random_uniform((uint32_t)self.texts.count);
    } while (randomIndex == self.lastIndex && self.texts.count > 1); // 只有1个元素时不循环
    
    self.lastIndex = randomIndex;
    return self.texts[randomIndex];
}
@end
