//
//  ASBaseModel.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//


import ObjectMapper

open class ASBaseModel: NSObject, Mappable, NSCopying {
    
    open func mapping(map: ObjectMapper.Map) {}
    
    open func copy(with zone: NSZone? = nil) -> Any {
        return Self.init(JSON: toJSON()) ?? Self.init(JSON: [:])!
    }
    
    required convenience public init?(map: ObjectMapper.Map) {
        self.init()
        mapping(map: map)
    }
    
    required convenience public init?(json: [String: Any]) {
        self.init(JSON: json)
    }
        
}
