//
//  ASBaseView.m
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//

#import "ASBaseView.h"

@implementation ASBaseView


- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self commonInit];
    }
    return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder {
    self = [super initWithCoder:coder];
    if (self) {
        [self commonInit];
    }
    return self;
}

- (void)commonInit {
    self.backgroundColor = [UIColor clearColor];
    
    // 初始化 contentView
    _contentView = [[UIView alloc] init];
    _contentView.backgroundColor = [UIColor clearColor];
    [self addSubview:_contentView];
    
    // 使用 Masonry 设置约束（相当于 Swift 的 SnapKit）
    [_contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.leading.trailing.bottom.equalTo(@0);
    }];
    
    // 调用子类实现的方法
    [self creatUI];
    [self dealThings];
}

- (void)creatUI {
    // 子类重写此方法
}

- (void)dealThings {
    // 子类重写此方法
}

@end
