//
//  ASBaseViewController.m
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//

#import "ASBaseViewController.h"
#import "Masonry.h"
#import "GlobalMacros.h"
#import "NSString+AS.h"
@interface ASBaseViewController ()

@end

@implementation ASBaseViewController

- (instancetype)init {
    self = [super initWithNibName:nil bundle:nil];
    if (self) {

    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setupSuperSomeView];
    [self createData];
    [self createView];
    [self dealThings];
}

- (void)setupSuperSomeView {
    self.edgesForExtendedLayout = UIRectEdgeAll;
    
    _contentView = [[UIView alloc] init];
    _navBarContentView = [[UIView alloc] init];
    _navBarContentView.backgroundColor = [UIColor clearColor];
    
    [self.view addSubview:_contentView];
    [self.view addSubview:_navBarContentView];
    
    [_contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(@(k_Nav_Height));
        make.leading.trailing.bottom.equalTo(self.view);
    }];
    
    [_navBarContentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.leading.top.trailing.equalTo(self.view);
        make.height.equalTo(@(k_Nav_Height));
    }];
    
    self.view.backgroundColor = @"#111018".uiColor;
    [self.view layoutIfNeeded];
}

- (void)createData {}
- (void)createView {}
- (void)dealThings {}

- (void)addNormalNavBarView {
    _normalNavBarView = [[ASNormalNavigationBarView alloc] init];
    [_navBarContentView addSubview:_normalNavBarView];
    [_normalNavBarView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(_navBarContentView);
    }];
}

- (void)viewWillAppear:(BOOL)animated {
    NSLog(@"进入------>%@", NSStringFromClass([self class]));
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    NSLog(@"♻️♻️♻️ ASBaseViewController -> %@ deinit ♻️♻️♻️", NSStringFromClass([self class]));
}

#pragma mark - 导航栏方法

- (void)setTitleText:(NSString *)title {
    [_normalNavBarView setTitleName:NSLocalizedString(title, @"")];
}

- (void)setPageTitle:(NSString *)title {
    [self setTitleText:title];
    [self setNavigationItem:@"" imageName:@"navi_back_white" direction:NSTextAlignmentLeft action:@selector(navBarClickLeftAction)];
}

- (UIButton *)setNavigationItem:(NSString *)name imageName:(NSString *)imageName direction:(NSTextAlignment)direction action:(SEL)action {
    if (direction == NSTextAlignmentLeft) {
        return [_normalNavBarView setLeftNavigationItemWithName:name imageName:imageName target:self action:action];
    } else {
        return [_normalNavBarView setRightNavigationItemWithName:name imageName:imageName target:self action:action];
    }
}

- (void)navBarClickLeftAction {
    NSLog(@"navBarClickLeftAction -> %@", NSStringFromClass([self class]));
    [self pop];
}

- (void)pop {
    if (self.navigationController == nil) {
        [self dismissViewControllerAnimated:YES completion:nil];
    } else if (self.navigationController.presentingViewController != nil && self.navigationController.viewControllers.count == 1) {
        [self.navigationController dismissViewControllerAnimated:YES completion:nil];
    } else {
        [self.navigationController popViewControllerAnimated:YES];
    }
}

- (void)setNavBarViewHidden:(BOOL)isHidden {
    [_navBarContentView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.equalTo(@(isHidden ? 0 : k_Nav_Height));
    }];
    
    [_contentView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(@(isHidden ? 0 : k_Nav_Height));
    }];
}

- (BOOL)isViewVisible {
    return self.isViewLoaded && self.view.window != nil && self.presentedViewController == nil;
}
@end
