//
//  Common.swift
//  AIPlayRingtones
//
//  Created by 100Years on 2025/5/15.
//

func kAddCommonGradientBg(view:UIView){
    view.setNeedsLayout()
    DispatchQueue.main.async {
        view.addGradientBg(colors: ["#202030".uiCGColor,"#343352".uiCGColor],startPoint: CGPoint(x: 0, y: 0),endPoint: CGPoint(x: 1, y: 0))
    }
}



public func k_StatusBarH() -> CGFloat {
    let scene = UIApplication.shared.connectedScenes.first;
    guard let windowScene = scene as? UIWindowScene else {return 0};
    guard let statusBarManager = windowScene.statusBarManager else {return 0};
    return statusBarManager.statusBarFrame.height
}

public func k_Height_safeAreaInsetsBottom() -> CGFloat {
    let scene = UIApplication.shared.connectedScenes.first;
    guard let windowScene = scene as? UIWindowScene else {return 0};
    guard let window = windowScene.windows.first else {return 0};
    return window.safeAreaInsets.bottom;
}
/** 屏幕宽度 */
public let k_ScreenWidth = UIScreen.main.bounds.size.width
/** 屏幕高度 */
public let k_ScreenHeight = UIScreen.main.bounds.size.height
/* 导航栏高度 固定高度 = 44.0f */
public let k_Height_NavBar :CGFloat = 44.0
/** 状态栏高度 */
public let k_StatusBar_H : CGFloat = k_StatusBarH()
/** 状态栏+导航栏的高度 */
public let k_Nav_Height: CGFloat = k_Height_NavBar + k_StatusBar_H
/** 底部tabBar栏高度（不包含安全区，即：在 iphoneX 之前的手机） */
public let k_TabBar_Height :CGFloat = 49.0
/** 底部导航栏高度（包括安全区），一般使用这个值 */
public let k_Height_TabBar :CGFloat = k_Height_safeAreaInsetsBottom() + k_TabBar_Height


//判断是否是 x、及x以上 系列
public func isIphoneX() -> Bool {
    return k_Height_safeAreaInsetsBottom() > 0.0; // 底部安全区 > 0 时，
    
}

//设计稿为 375*812 比例,所以比例系数为 375.0/kScreenWidth
public let kDesignScale = k_ScreenWidth/375.0


public func kGetUIH(designSize:CGSize,currentW:CGFloat) -> CGFloat {
    let scale = designSize.width/currentW
    return designSize.height/scale
}
    

public func logPrint<T>(_ messsage: T) {
    #if DEBUG
    print(Date.hmsString + " \(messsage)")
    #endif
}

public func appShortVersion() ->String{
    let short = Bundle.main.infoDictionary?["CFBundleShortVersionString"] as? String ?? ""
    return short
}

public func appVersion() ->String{
    return "V" + appShortVersion()
}


public func kPresentModalVC(target:UIViewController,
                     modelVC:UIViewController,
                       style:UIModalPresentationStyle = .overFullScreen,
             transitionStyle:UIModalTransitionStyle = .coverVertical,
                  completion: (() -> Void)? = nil){
    let navi = ASBaseNavigationController(rootViewController: modelVC)
    navi.modalPresentationStyle = style
    navi.modalTransitionStyle = transitionStyle
    target.present(navi, animated: true,completion: completion)
}

public func kPushVC(target:UIViewController,modelVC:UIViewController){
    modelVC.hidesBottomBarWhenPushed = true
    target.navigationController?.pushViewController(modelVC, animated: true)
}

public func kShowToastDataMissing(){
    logPrint("参数缺失")
}




var modelIdentifier: String {
    var systemInfo = utsname()
    uname(&systemInfo)
    
    let machineMirror = Mirror(reflecting: systemInfo.machine)
    let identifier = machineMirror.children.reduce("") { (identifier, element) in
        guard let value = element.value as? Int8, value != 0 else {
            return identifier
        }
        return identifier + String(UnicodeScalar(UInt8(value)))
    }
    
    return identifier
}

var deviceName: String = {
    
    let identifier = modelIdentifier
    
    switch identifier {
    case "iPhone8,1":
        return "iPhone 6s"
    case "iPhone8,2":
        return "iPhone 6s Plus"
    case "iPhone8,4":
        return "iPhone SE"
    case "iPhone9,1":
        return "iPhone 7"; //国行、日版、港行
    case "iPhone9,2":
        return "iPhone 7 Plus"; //国行、港行
    case "iPhone9,3":
        return "iPhone 7"; //美版、台版
    case "iPhone9,4":
        return "iPhone 7 Plus"; //美版、台版
    case "iPhone10,1":
        return "iPhone 8"; //国行(A1863)、日行(A1906)
    case "iPhone10,2":
        return "iPhone 8 Plus"; //国行(A1864)、日行(A1898)
    case "iPhone10,3":
        return "iPhone X"; //国行(A1865)、日行(A1902)
    case "iPhone10,4":
        return "iPhone 8"; //美版(Global/A1905)
    case "iPhone10,5":
        return "iPhone 8 Plus"; //美版(Global/A1897)
    case "iPhone10,6":
        return "iPhone X";//美版(Global/A1901)
        
    // 刘海屏(除SE外)
    case "iPhone11,8":
        return "iPhone XR"
    case "iPhone11,2":
        return "iPhone XS"
    case "iPhone11,6":
        return "iPhone XS Max"
    case "iPhone11,4":
        return "iPhone XS Max"
    case "iPhone12,1":
        return "iPhone 11"
    case "iPhone12,3":
        return "iPhone 11 Pro"
    case "iPhone12,5":
        return "iPhone 11 Pro Max"
    case "iPhone12,8":
        return "iPhone SE2"; //(2nd generation)
    case "iPhone13,1":
        return "iPhone 12 mini"
    case "iPhone13,2":
        return "iPhone 12"
    case "iPhone13,3":
        return "iPhone 12 Pro"
    case "iPhone13,4":
        return "iPhone 12 Pro Max"
    case "iPhone14,2":
        return "iPhone 13 Pro"
    case "iPhone14,3":
        return "iPhone 13 Pro Max"
    case "iPhone14,4":
        return "iPhone 13 mini"
    case "iPhone14,5":
        return "iPhone 13"
    case "iPhone14,6":
        return "iPhone SE3"; //(2nd generation)
    case "iPhone14,7":
        return "iPhone 14"
    case "iPhone14,8":
        return "iPhone 14 Plus"
        
    // 灵动岛
    case "iPhone15,2":
        return "iPhone 14 Pro"
    case "iPhone15,3":
        return "iPhone 14 Pro Max"
        
    case "iPhone16,2":
        return "iPhone 15 Pro Max"
    case "iPhone16,1":
        return "iPhone 15 Pro"
    case "iPhone15,5":
        return "iPhone 15 Plus"
    case "iPhone15,4":
        return "iPhone 15"

        
    case "iPhone17,3":
        return "iPhone 16"
    case "iPhone17,4":
        return "iPhone 16 Plus"
    case "iPhone17,1":
        return "iPhone 16 Pro"
    case "iPhone17,2":
        return "iPhone 16 Pro Max"
        
        
        
    default:
        return "--"
    }
}()





public let kMainQueue = DispatchQueue.main
/// 主线程延迟执行回调
/// - Parameters:
///   - delay: 延迟时间（秒）
///   - completion: 延迟后的回调
public func kDelayOnMainThread(_ delay: TimeInterval, completion: @escaping () -> Void) {
    DispatchQueue.main.asyncAfter(deadline: .now() + delay) {
        completion()
    }
}

public func kDelayMainShort(completion: @escaping () -> Void) {
    DispatchQueue.main.asyncAfter(deadline: .now() + 0.1) {
        completion()
    }
}

/// 在主线程上执行代码
/// - Parameter block: 要执行的代码块
public func kExecuteOnMainThread(_ block: @escaping () -> Void) {
    if Thread.isMainThread {
        block()
    } else {
        DispatchQueue.main.async {
            block()
        }
    }
}


/// 子 size 根据容器 size,返回自己的最大 size
/// - Parameters:
///   - containerSize: 容器 Size
///   - subviewSize: 子 Size
///   - contentInset: contentInset
///   - contentMode: contentMode
/// - Returns: 最大 size
public func kCalculateScaledSize(containerSize: CGSize, subviewSize: CGSize, contentInset: UIEdgeInsets = .zero ,contentMode:UIView.ContentMode) -> CGSize {
    // 计算去除边距后的容器可用大小
    let availableWidth = containerSize.width - contentInset.left - contentInset.right
    let availableHeight = containerSize.height - contentInset.top - contentInset.bottom
    
    switch contentMode {
    case .scaleToFill:
        // 直接填充容器，忽略子视图比例
        return CGSize(width: availableWidth, height: availableHeight)
    case .scaleAspectFit:
        // 按比例适配容器，确保子视图完全显示在容器内
        let widthRatio = availableWidth / subviewSize.width
        let heightRatio = availableHeight / subviewSize.height
        let scale = min(widthRatio, heightRatio)
        return CGSize(width: subviewSize.width * scale, height: subviewSize.height * scale)
    case .scaleAspectFill:
        // 按比例填充容器，可能会裁剪子视图
        let widthRatio = availableWidth / subviewSize.width
        let heightRatio = availableHeight / subviewSize.height
        let scale = max(widthRatio, heightRatio)
        return CGSize(width: subviewSize.width * scale, height: subviewSize.height * scale)
    default:
        // 默认返回子视图原始大小
        return subviewSize
    }
}


public func kGetCollectionViewCellSize(sectionInset:UIEdgeInsets,
               itemSpacing:CGFloat,
               originalSize:CGSize,
               cellRowNum:Int)->CGSize{
    let widthReduction:CGFloat = 1.0
    let originalScale = originalSize.width/originalSize.height
    var w = k_ScreenWidth-sectionInset.left-sectionInset.right-widthReduction
    w = w - itemSpacing * CGFloat((cellRowNum-1))
    w = w/CGFloat(cellRowNum)
    let h = w/originalScale
    let cellSize = CGSizeMake(w, h)
    return cellSize
}


public extension Array {
    func safeAny(At index: Int) -> Element? {
        if index >= 0,  index < count {
            return self[index]
        }
        return nil
    }
}


public extension Float {
    var timeMMSS:String {
        return "\(String(format: "%02d", Int(self) / 60)):\(String(format: "%02d", Int(self) % 60))"
    }
}

public extension Date {
    static var timestampInt: Int {
        return Int(Date().timeIntervalSince1970)
    }
    
    static var hmsString: String {
        let formatter = DateFormatter()
        formatter.locale = Locale(identifier: "en")
        formatter.dateFormat = "HH:mm:ss:SSS"
        return formatter.string(from: Date())
    }
}


public extension UIImage {
    // 压缩图片到指定尺寸
    func compressSize(to size: CGSize) -> UIImage {
        let targetSize = size
        if self.size.width > targetSize.width || self.size.height > targetSize.height {
            return kf.resize(to: targetSize)
        }
        return self
    }
    
}


func kshareBand(needVip:Bool,
               vc:UIViewController,
                fileURL:URL,
                fileName:String,
                completion:((Bool)->Void)? = nil) -> Bool {
    ASGarageBandHelper.create().shareToGarageBand(from: vc, withAudio: fileURL, fileName: fileName, completion: completion)
    return false
}
