//
//  UIFont+AS.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/28.
//

public extension String {
    static let PingFangSC   = "PingFangSC"
    static let PoppinsBoldItalic   = "Poppins-BoldItalic"
}

public extension UIFont {
    static func font(name: String = .PingFangSC, size: CGFloat, weight: UIFont.Weight = .regular) -> UIFont {
        guard !name.isEmpty, UIFont(name: name, size: size) != nil else {
           return systemFont(ofSize: size, weight: weight)
       }
       
       var selectedFontName = name
       
       let availableFonts = UIFont.fontNames(forFamilyName: name)
       let weightMapping: [UIFont.Weight: [String]] = [
           .light: ["-light", "_light"],//细体 300
           .medium: ["-medium", "_medium"],////中黑体 500
           .bold: ["-bold", "_bold"],//// 粗体 700
           .semibold: ["-semibold", "_semibold"],//半粗体 600
           .heavy: ["-heavy", "_heavy"],//粗黑体 800
           .black: ["-black", "_black"] // 黑体 900
       ]
       
       if let suffixes = weightMapping[weight] {
           for suffix in suffixes {
               if let matchedFont = availableFonts.first(where: { $0.lowercased().hasSuffix(suffix) }) {
                   selectedFontName = matchedFont
                   break
               }
           }
       }
       
       return UIFont(name: selectedFontName, size: size) ?? systemFont(ofSize: size, weight: weight)
    }
}
