//
//  UILabel+AS.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//

public extension UILabel {
    static func createLabel(text: String? = nil,
                            font: UIFont? = nil,
                            textColor: UIColor? = nil,
                            textAlignment: NSTextAlignment = .left,
                            numberOfLines: Int = 0,
                            backgroundColor: UIColor? = nil,
                            adjustsFontSizeToFitWidth: Bool = false,
                            cornerRadius: CGFloat = 0) -> UILabel {
        let label = UILabel()
        if let font = font {
            label.font = font
        }
        if let textColor = textColor {
            label.textColor = textColor
        }
        label.numberOfLines = numberOfLines
        label.text = text
        label.adjustsFontSizeToFitWidth = adjustsFontSizeToFitWidth
        label.textAlignment = textAlignment
        if cornerRadius > 0 {
            label.layer.cornerRadius = cornerRadius
            label.layer.masksToBounds = true
        }
        if let backgroundColor = backgroundColor {
            label.backgroundColor = backgroundColor
        }
        return label
    }
}
