//
//  UIViewController+AS.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/28.
//

public extension UIViewController {
    
    func showCustomAlert(
        title: String? = "",
        message: String?,
        rightActionString:String = "Delete".localized,
        deleteHandler: (() -> Void)? = nil,
        cancelHandler: (() -> Void)? = nil
    ) {
        let alert = UIAlertController(title: nil, message: nil, preferredStyle: .alert)
        alert.overrideUserInterfaceStyle = .dark
        if let title = title {
            alert.setValue(NSAttributedString(string: title, attributes: [
                .font: UIFont.boldSystemFont(ofSize: 20),
                .foregroundColor: UIColor.white
            ]), forKey: "attributedTitle")
        }
        if let message = message {
            alert.setValue(NSAttributedString(string: message, attributes: [
                .font: UIFont.boldSystemFont(ofSize: 17),
                .foregroundColor: UIColor.white
            ]), forKey: "attributedMessage")
        }
        alert.addAction(UIAlertAction(title: "Cancel".localized, style: .cancel) { _ in
            cancelHandler?()
        })
        alert.addAction(UIAlertAction(title: rightActionString, style: .destructive) { _ in
            deleteHandler?()
        })
        present(alert, animated: true, completion: nil)
    }

}
