//
//  GlobalMacros.h
//  AIPlayRingtones
//
//  Created by mini on 2025/5/27.
//

#ifndef GlobalMacros_h
#define GlobalMacros_h

// 防止重复包含的宏
#pragma once

// 屏幕尺寸宏定义
#define k_ScreenWidth [UIScreen mainScreen].bounds.size.width
#define k_ScreenHeight [UIScreen mainScreen].bounds.size.height
#define k_Height_NavBar 44.0f
#define k_TabBar_Height 49.0f

// 状态栏高度
static inline CGFloat k_StatusBar_H() {
    if (@available(iOS 13.0, *)) {
        UIWindowScene *windowScene = [UIApplication sharedApplication].connectedScenes.allObjects.firstObject;
        return windowScene.statusBarManager.statusBarFrame.size.height;
    } else {
        return [UIApplication sharedApplication].statusBarFrame.size.height;
    }
}

// 安全区高度
static inline CGFloat k_Height_safeAreaInsetsTop() {
    if (@available(iOS 13.0, *)) {
        UIWindowScene *windowScene = [UIApplication sharedApplication].connectedScenes.allObjects.firstObject;
        return windowScene.windows.firstObject.safeAreaInsets.top;
    } else if (@available(iOS 11.0, *)) {
        return [UIApplication sharedApplication].windows.firstObject.safeAreaInsets.top;
    }
    return 0;
}

static inline CGFloat k_Height_safeAreaInsetsBottom() {
    if (@available(iOS 13.0, *)) {
        UIWindowScene *windowScene = [UIApplication sharedApplication].connectedScenes.allObjects.firstObject;
        return windowScene.windows.firstObject.safeAreaInsets.bottom;
    } else if (@available(iOS 11.0, *)) {
        return [UIApplication sharedApplication].windows.firstObject.safeAreaInsets.bottom;
    }
    return 0;
}

// 组合高度
#define k_StatusBar_H k_StatusBar_H()
#define k_Nav_Height (k_Height_NavBar + k_StatusBar_H)
#define k_Height_TabBar (k_Height_safeAreaInsetsBottom() + k_TabBar_Height)

// 判断iPhoneX系列
static inline BOOL isIphoneX() {
    return k_Height_safeAreaInsetsBottom() > 0.0;
}

#define k_StatusBar_H k_StatusBar_H()

#endif /* GlobalMacros_h */
