//
//  ASRingToneCellView.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/18.
//


class ASRingToneCellView: ASBaseView {
    
    var clickPlayHandel:((Bool)->Void)?
    var isSelectedChangeColor:Bool = true //选中是否改变颜色
    
    lazy var bgImageView: UIImageView = {
        let bgImageView:UIImageView = UIImageView()
        bgImageView.image = .cellRingBg
        return bgImageView
    }()
    
    lazy var selectedBoardImageView: UIImageView = {
        let selectedBoardImageView:UIImageView = UIImageView()
        selectedBoardImageView.image = .cellRingSelected
        selectedBoardImageView.isHidden = true
        return selectedBoardImageView
    }()
    
    lazy var coverImageView: UIImageView = {
        let coverImageView:UIImageView = UIImageView()
        coverImageView.image = .cellRing
        return coverImageView
    }()
    
    lazy var progressView: TSRingProgressView = {
        let progressView = TSRingProgressView()
        progressView.isHidden = true
        progressView.generateProgressView.image = nil
        return progressView
    }()
    
    let playBtn = UIButton.createBtn(image: UIImage(named: "cell_ring_play"))
    let nameLab = UILabel.createLabel(text: "--",font: .font(size: 14),textColor: .white,numberOfLines: 1)
    let timeLab = UILabel.createLabel(text:"--:--",font: .font(size: 12),textColor: .white.withAlphaComponent(0.6))
    
 
    var clickSetUpHandel:(()->Void)?
    lazy var setRingBtn: ASTouchBtn = {
        let setRingBtn = ASTouchBtn()
        setRingBtn.setUpBtn(image: UIImage(named: "cell_setRing_icon")){ [weak self]  in
            guard let self = self else { return }
            clickSetUpHandel?()
        }
        setRingBtn.isHidden = true
        return setRingBtn
    }()
    
    var clickEditHandel:(()->Void)?
    lazy var editBtn: ASTouchBtn = {
        let editBtn = ASTouchBtn()
        editBtn.setUpBtn(image: UIImage(named: "edit_ring_icon")){ [weak self]  in
            guard let self = self else { return }
            clickEditHandel?()
        }
        editBtn.isHidden = true
        return editBtn
    }()
    
    lazy var clearBtn = UIButton.createBtn{[weak self]  in
        guard let self = self else { return }
        clickPlayHandel?(self.isPlay)
    }
    
    lazy var rightShade: UIImageView = {
        let rightShade = UIImageView.createImageV(imageName: "play_right_shade",contentMode: .scaleAspectFill)
        rightShade.isHidden = true
        return rightShade
    }()
    
    var isPlay:Bool = false {
        didSet{
            playBtn.stopRotating()
            playBtn.setImage(UIImage(named: isPlay ? "cell_ring_pause" : "cell_ring_play"), for: .normal)
            if isSelectedChangeColor {
//                backgroundColor = isPlay ? selectedColor : .cardColor
                bgImageView.image = isPlay ? .cellRingSelected : .cellRingBg
            }
            
        }
    }
    
    var isloading:Bool = false {
        didSet{
            if isloading {
                playBtn.setImage(UIImage(named:"cell_ring_loading"), for: .normal)
                playBtn.startRotating()
            }else{
                let b = isPlay
                isPlay = b
                playBtn.stopRotating()
            }
        }
    }
    
    
    
    override func creatUI() {
//        backgroundColor = .cardColor
        cornerRadius = 16
        coverImageView.cornerRadius = 24
        coverImageView.backgroundColor = .black
        
        contentView.addSubview(bgImageView)
        contentView.addSubview(selectedBoardImageView)
        contentView.addSubview(coverImageView)
        contentView.addSubview(progressView)
        coverImageView.addSubview(playBtn)
        contentView.addSubview(nameLab)
        contentView.addSubview(timeLab)
        
        bgImageView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
        selectedBoardImageView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
        coverImageView.snp.makeConstraints { make in
            make.leading.equalTo(12)
            make.centerY.equalToSuperview()
            make.width.height.equalTo(48)
        }
        
        playBtn.snp.makeConstraints { make in
            make.center.equalToSuperview()
            make.width.height.equalTo(28)
        }

        nameLab.snp.makeConstraints { make in
            make.leading.equalTo(76)
            make.trailing.equalTo(-50)
            make.top.equalTo(17)
        }
        
        timeLab.snp.makeConstraints { make in
            make.leading.equalTo(76)
            make.bottom.equalTo(-17)
            make.height.equalTo(12)
        }
        
        progressView.snp.makeConstraints { make in
            make.leading.equalTo(timeLab.snp.trailing).offset(8)
            make.centerY.equalTo(timeLab.snp.centerY)
            make.trailing.equalTo(-52)
        }
        
        contentView.addSubview(rightShade)
        rightShade.snp.makeConstraints { make in
            make.trailing.top.bottom.equalToSuperview()
            make.width.equalTo(103*kDesignScale)
        }
        
        
        contentView.addSubview(clearBtn)
        clearBtn.snp.makeConstraints { make in
            make.leading.top.bottom.equalToSuperview()
            make.trailing.equalTo(0)
        }
        
        contentView.addSubview(setRingBtn)
        setRingBtn.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.trailing.equalTo(-16)
            make.width.height.equalTo(20)
        }
        
        contentView.addSubview(editBtn)
        editBtn.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.trailing.equalTo(setRingBtn.snp.leading).offset(-20)
            make.width.height.equalTo(20)
        }
    }
    
    
    func setCoverImageView(urlString:String){
        coverImageView.setImageAsync(urlString: urlString,placeholder:.cellRing,contentMode: .scaleAspectFill,showLoading: false)
    }
    
}

extension ASRingToneCellView {
    
    func monitorPlayStateDefaultHandle(){
        ASMediaPlayerController.main.onStatusChange = { [weak self] state  in
            guard let self = self else { return }
            DispatchQueue.main.async {
                self.handelAudioPlayerStateChange(state: state)
            }
        }
    }
    
    func handelAudioPlayerStateChange(state:ASMediaPlayerController.PlaybackStatus){
        logPrint("ASRingToneCellView handelAudioPlayerStateChange=\(state),self=\(self)")
        switch state {
        case .buffering(let progress):
            if progress == 0.0 {
                self.isloading = true
            }else if progress == 1.0 {
                self.isloading = false
            }
        case .playing:
            self.isPlay = true
        case .stopped:
            self.isloading = false
            self.isPlay = false
            self.progressView.isHidden = true
            self.progressView.progress = 0.0
        case .timeUpdated(_):
            self.isPlay = true
            self.progressView.isHidden = false
            self.progressView.progress = Float(ASMediaPlayerController.main.playbackProgress)
        default:
            break
        }
    }
    
}


class TSRingToneGenerateView:ASBaseView {
    
    
    var refreshHandel:(()->Void)?

    lazy var bgImageView: UIImageView = {
        let bgImageView = UIImageView.createImageV(image: .cellRingBg,contentMode: .scaleToFill)
        return bgImageView
    }()
    
    lazy var progressLabel: UILabel = {
        let progressLabel = UILabel.createLabel(text:"Working on your ringtone...".localized,font: .font(size: 14),textColor: .white,numberOfLines: 1)
        return progressLabel
    }()
    
    lazy var progressView: TSRingProgressView = {
        let progressView = TSRingProgressView()
        return progressView
    }()
    
    lazy var iconImageView: UIImageView = {
        let iconImageView = UIImageView.createImageV(imageName: "cell_ring_icon",contentMode: .scaleToFill)
        return iconImageView
    }()
    

    lazy var infoLabel: UILabel = {
        let infoLabel = UILabel.createLabel(font: .font(size: 14),textColor: .white)
        return infoLabel
    }()
    
    lazy var refreshBtn: ASTouchBtn = {
        let refreshBtn = ASTouchBtn()
        refreshBtn.setUpBtn(image: .refreshPurple){[weak self]  in
            guard let self = self else { return }
            refreshHandel?()
        }
        refreshBtn.isHidden = true
        return refreshBtn
    }()
    
    
    override func creatUI() {
        backgroundColor = .cardColor
        
        contentView.addGestureRecognizer(UITapGestureRecognizer(target: self, action: #selector(clickContentView)))
        
        contentView.addSubview(bgImageView)
        bgImageView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
 
        contentView.addSubview(iconImageView)
        iconImageView.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.width.height.equalTo(48.0)
            make.leading.equalTo(12.0)
        }
        
        contentView.addSubview(progressLabel)
        progressLabel.snp.makeConstraints { make in
            make.leading.equalTo(iconImageView.snp.trailing).offset(20)
            make.top.equalTo(22)
            make.trailing.equalTo(-16)
        }
        
        contentView.addSubview(progressView)
        progressView.snp.makeConstraints { make in
            make.leading.equalTo(iconImageView.snp.trailing).offset(20)
            make.bottom.equalTo(-22)
            make.trailing.equalTo(-16)
        }
        
        
        contentView.addSubview(infoLabel)
        infoLabel.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.leading.equalTo(iconImageView.snp.trailing).offset(20)
            make.trailing.equalTo(-40)
        }
        
        contentView.addSubview(refreshBtn)
        refreshBtn.snp.makeConstraints { make in
            make.trailing.equalTo(-16)
            make.centerY.equalToSuperview()
            make.width.height.equalTo(20.0)
        }
        
    }
    
    @objc func clickContentView() {
        if refreshBtn.isHidden == false{
            refreshHandel?()
        }
    }
    
    func setProgress(progress:Float) {
        progressLabel.isHidden = false
        progressView.isHidden = false
        progressView.setProgress(progress: progress)
        
        infoLabel.isHidden = true
        refreshBtn.isHidden = true
    }
    
    func setFail(){
        progressLabel.isHidden = true
        progressView.isHidden = true
        progressView.setProgress(progress: 0)
        
        infoLabel.text = "Generation Failed".localized
        infoLabel.isHidden = false
        refreshBtn.isHidden = false
    }
}


class TSRingProgressView:ASBaseView {
    
    lazy var generateProgressView: UIImageView = {
        let generateProgressView = UIImageView.createImageV(imageName: "cell_ring_progress",contentMode: .scaleToFill)
        generateProgressView.backgroundColor = .white
        generateProgressView.cornerRadius = 1.0
        return generateProgressView
    }()
    
    override func creatUI() {
   
        contentView.backgroundColor = .white.withAlphaComponent(0.2)
        contentView.cornerRadius = 1.0
        contentView.addSubview(generateProgressView)
        
        contentView.snp.remakeConstraints { make in
            make.edges.equalToSuperview()
            make.height.equalTo(2)
        }
        
//        generateProgressView.snp.makeConstraints { make in
//            make.leading.top.bottom.equalTo(0)
//            make.width.equalToSuperview().multipliedBy(0.0)
//        }
        
        generateProgressView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
        
        let maskLayer = CAShapeLayer()
        maskLayer.path = UIBezierPath(
            roundedRect: CGRect(x: 0, y: 0, width: self.width * CGFloat(progress) , height: self.height),
            cornerRadius: 1
        ).cgPath
        generateProgressView.layer.mask = maskLayer
    }

    func setProgress(progress:Float) {
//        generateProgressView.snp.remakeConstraints{ make in
//            make.leading.top.bottom.equalTo(0)
//            make.width.equalToSuperview().multipliedBy(progress)
//        }
        
        if let maskLayer = generateProgressView.layer.mask as? CAShapeLayer {
            maskLayer.path = UIBezierPath(
                roundedRect: CGRect(x: 0, y: 0, width: self.width * CGFloat(progress) , height: self.height),
                cornerRadius: 1
            ).cgPath
        }

    }
    
    
    var progress:Float = 0.0{
        didSet{
            setProgress(progress: progress)
        }
    }
    
}
