//
//  ASProgressState.swift
//  AIPlayRingtones
//
//  Created by 100Years on 2025/5/16.
//


import Combine
import Alamofire
enum ASProgressState  {
    case none
    case start
    case pending
    case progress(Float,String)
    case success(Any?)
    case failed(String,Int)

    var isResult:Bool{
        switch self {
        case .none:
            return false
        case .start:
            return false
        case .pending:
            return false
        case .progress(_,_):
            return false
        case .success(_):
            return true
        case .failed(_,_):
            return true
        }
    }
    
    
    var reslutSuccess:Bool{
        switch self {
        case .success(_):
            return true
        case .failed(_,_):
            return false
        default:
            return false
        }
    }
    
    
    var reloadNewData:Bool{
        switch self {
        case .start,.pending,.success(_),.failed(_,_):
            return true
        default:
            return false
        }
    }
    
    static func getFailed(_ error:String,_ code:Int = 0)->ASProgressState {
        return .failed(error, code)
    }
    
    static var generalNormalFailed:ASProgressState {
        return .failed(ASErrorCode.generalFailure.localizedDescription, ASErrorCode.generalFailure.rawValue)
    }
}
