//
//  ASGenerateRingToRingOperation.swift
//  AIPlayRingtones
//
//  Created by mini on 2025/5/19.
//


import Combine
import Alamofire
import ObjectMapper
import Kingfisher
class ASGenerateRingToRingOperationQueue: ASGenerateBaseOperationQueue {
    static let shared:ASGenerateRingToRingOperationQueue = ASGenerateRingToRingOperationQueue()

    func creatOperation(uuid: String) -> ASGenerateRingToRingOperation {
        let operation = super.creatOperation(uuid: uuid, type: ASGenerateRingToRingOperation.self)
        handleStateDatauPblished(uuid: uuid, generateOperation: operation as! ASGenerateBaseOperation, notificationName: .kGenerateRTROperationChanged)
        return operation as! ASGenerateRingToRingOperation
    }
    
    override func getUUIDData(uuid:String)->(ASProgressState,ASActionInfoModel?){
        if let PosterOperation = ASGenerateRingToRingOperationQueue.shared.findOperation(uuid: uuid) as? ASGenerateRingToRingOperation {
            logPrint("ASBaseOperation stateDatauPblished 发送 = \(PosterOperation.stateDatauPblished)")
            return (PosterOperation.stateDatauPblished.0,PosterOperation.currentActionInfoModel)
        }
        return (.none,ASActionInfoModel())
    }
    
}


class ASGenerateRingToRingOperation: ASGenerateTextToRingOperation , @unchecked Sendable{

    var uploadRequest:Request?

    func uploadFile(generateStyleModel:ASGenerateStyleModel,complete:@escaping (ASActionInfoModel?)->Void) {
        
        guard let upLoadFilePath = generateStyleModel.upLoadFilePath else { return  }
        if let uploadUrl = generateStyleModel.upLoadUrl,uploadUrl.contains("http") {
            complete(createActionInfoModel(generateStyleModel: generateStyleModel))
            return
        }
        
        stopNetwork = false
        stateDatauPblished = (.start,nil)
        
        stateDatauPblished = (.progress(0.0,uploadingString(progress: 0.0)),currentActionInfoModel)
        uploadRequest = ASNetworkShared.sendAudioFile(audioFileURL: upLoadFilePath, uploadProgress: { [weak self]  progress in
            guard let self = self else { return }
            if generatingProgress == 0 {
                stateDatauPblished = (.progress(progress,uploadingString(progress: progress)),currentActionInfoModel)
            }
        }, completion: { [weak self]  data, error in
            guard let self = self else { return }
            if stopNetwork == true { return }
            if let error = error {
                generateStyleModel.upLoadUrl = nil
                self.stateDatauPblished = (ASProgressState.getFailed(error.xhLocalizedMessage,error.xhStatusCode),nil)
                complete(nil)
            }else{
                if let string = data as? String {
                    generateStyleModel.upLoadUrl = string

                    complete(createActionInfoModel(generateStyleModel: generateStyleModel))
                }else{
                    complete(nil)
                }
            }
        })
    }

    func uploadingString(progress:Float) -> String {
        //Uploading Photo 0%-100%
        var progressInt = Int(progress*100)
        if progressInt > 99 {
            progressInt = 99
        }
        return "Uploading Photo".localized + " \(progressInt)%"
    }
    
    override func cancelCleanContent() {
        super.cancelCleanContent()
        uploadRequest?.cancel()
    }
}
